elementclass WingRouter {
  $ip, $nm, $rate, $debug|


outgoing :: SetTXRate($rate)
 -> [0] output

es :: LinkStat($debug);


gw :: WINGGatewaySelector(IP $ip, 
                         PERIOD 15000,
                         JITTER 1000,
                         EXPIRE 30000,
                         LT lt, 
                         ARP arp,
                         DEBUG $debug);

set_gw :: WINGSetGateway(SEL gw);


forwarder :: WINGForwarder(IP $ip, 
                          LT lt, 
                          ARP arp,
                          DEBUG $debug);


set_route :: WINGSetSourceRoute(IP $ip, 
                             FWD forwarder,
			     DEBUG $debug);


querier :: WINGQuerier(QUERY_WAIT 5,
                         TIME_BEFORE_SWITCH 5,
                         FWD forwarder,
                         LT lt, 
                         DEBUG $debug);


query_forwarder :: WINGMetricFlood(IP $ip, 
                                  LT lt, 
                                  ARP arp,
                                  DEBUG $debug);


query_responder :: WINGQueryResponder(IP $ip,
                                     LT lt, 
                                     ARP arp,
                                     DEBUG $debug);


reply_forwarder :: WINGReplyForwarder(IP $ip, 
                                     LT lt, 
                                     ARP arp,
                                     DEBUG $debug);


gw_responder ::  WINGGatewayResponder(IP $ip,
                                 PERIOD 15000,
                                 SEL gw, 
                                 LT lt, 
                                 RESPONDER query_responder,
                                 DEBUG $debug);


gw -> outgoing;
gw_responder -> outgoing;
query_responder -> outgoing;
reply_forwarder -> outgoing;
query_forwarder -> outgoing;

query_forwarder [1] -> query_responder;


input [1] 
-> host_cl :: IPClassifier(dst net $ip mask $nm, -)
-> set_route
-> [1] output;


set_route [1] -> querier -> [1] output;


host_cl [1] -> [0] set_gw [0] -> set_route;


forwarder[0] 
  -> dt ::DecIPTTL
  -> [1] output;


dt[1] 
-> ICMPError($ip, timeexceeded, 0) 
-> set_route;


querier [1] -> [0] query_forwarder;
es -> SetTimestamp() -> [0] output;


forwarder[1] // IP packets to me
  -> WINGStripHeader()
  -> CheckIPHeader(CHECKSUM false)
  -> from_gw_cl :: IPClassifier(src net $ip mask $nm, -)
  -> [2] output;


from_gw_cl [1] -> [1] set_gw [1] -> [2] output;


input [0]
  -> ncl :: Classifier(15/01 , // forwarder
                       15/02 , // queries
                       15/03 , // replies
                       15/04 , // es
                       15/05 , // gw
                      );
 
 
 ncl[0] -> forwarder;
 ncl[1] -> [1] query_forwarder
 ncl[2] -> reply_forwarder;
 ncl[3] -> es;
 ncl[4] -> gw;

}
